
package com.bd.framework.accessapi;

import java.io.Serializable;

import com.bd.framework.util.Command;

/**
 * <p>
 * Find an entity by its id.
 * Access command for finding an object by id. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 *
 */
public interface FindByIdAccess<T, ID extends Serializable> extends Command {
    
    void setLock(boolean lock);

    void setId(ID id);
    
    /**
     * The result of the command.
     */
    T getResult();


} 