
package com.bd.framework.accessapi;
import com.bd.framework.accessimpl.GenericAccessFactoryImpl;
import com.bd.framework.util.FactoryConfiguration;
import com.bd.framework.util.FactoryHelper;

/**
 * <p>
 * Interface for factory that creates Generic Access objects. 
 * </p>
 * <p>
 * Abstract factory design pattern.
 * </p>
 *
 */
public interface GenericAccessFactory<T> {

    FindByIdAccess<T, String> createFindByIdAccess();
     
    CreateAccess<T> createCreateAccess();
     
    UpdateAccess<T> createUpdateAccess();
     
    FindByQueryAccess<T> createFindByQueryAccess();
     
    FindByExampleAccess<T> createFindByExampleAccess();
     
    DeleteAccess<T> createDeleteAccess();
     


} 