
package com.bd.framework.accessapi;

import com.bd.framework.util.Command;

/**
 * <p>
 * Update an entity. It can save (create new) or update an entity.
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 */
public interface UpdateAccess<T> extends Command {


    void setEntity(T entity);
    
    /**
     * If save is true it will save the entity if it doesn't exist.
     * If save is true it will only try to update an existing entity.
     * Default is true.
     */
    void setSave(boolean save);



} 