
package com.bd.movie.domain;

import com.bd.framework.accessapi.*;
import com.bd.framework.accessimpl.GenericAccessFactoryImpl;

import com.bd.movie.accessapi.*;

import com.bd.movie.accessapi.LibraryAccessFactory;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <!-- begin-user-doc -->
 * Repository for Library
 * <!-- end-user-doc -->
 *
 * @generated
 */
public class LibraryRepository {

    /**
     * Reference to the access object factory. 
     * @generated 
     */
    private LibraryAccessFactory libraryAccessFactory = LibraryAccessFactory.getInstance();
    
    private GenericAccessFactory<Media> mediaAccessFactory = new GenericAccessFactoryImpl<Media>(Media.class);

    /** @generated */
    public LibraryRepository() {
    }
    

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     public Library forId(int id) throws LibraryNotFoundException {
        FindByIdAccess<Library, Integer> ao = libraryAccessFactory.createFindByIdAccess();        
        ao.setId(id);
        ao.execute();
        if (ao.getResult() == null) {
            throw new LibraryNotFoundException("No Library found with id: " + id);
        }
        return ao.getResult();       
     }
     
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     public void create(Library entity)  {
        CreateAccess<Library> ao = libraryAccessFactory.createCreateAccess();        
        ao.setEntity(entity);
        ao.execute();       
     }
     
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     public List<Library> findByQuery(String query, Map parameters)  {
        FindByQueryAccess<Library> ao = libraryAccessFactory.createFindByQueryAccess();        
        ao.setQuery(query);        
        ao.setParameters(parameters);
        ao.execute();
        return ao.getResult();       
     }
     
     /**
      * <!-- begin-user-doc -->
      * <!-- end-user-doc -->
      * 
      */
      public Library findLibraryByName(String name)  {
          String query = "select library from Library as library where library.name = :name";
          Map parameters = new HashMap();
          parameters.put("name", name);
          List<Library> result = findByQuery(query, parameters);
          if (result.isEmpty()) {
              return null;
          } else {
              return result.get(0);
          }
      }
     
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     public int getNumberOfMovies(int libraryId)  {
        GetNumberOfMoviesAccess ao = libraryAccessFactory.createGetNumberOfMoviesAccess();        
        ao.setLibraryId(libraryId);
        ao.execute();
        return ao.getResult();       
     }
     
     /**
      * <!-- begin-user-doc -->
      * <!-- end-user-doc -->
      * 
      */
     public List<Media> findMediaByName(int libraryId, String name)  {
          String query = "select media from Media as media where media.title = :name " +
              "and media.physicalMedia.library.id = :libraryId";
          Map parameters = new HashMap();
          parameters.put("libraryId", libraryId);
          parameters.put("name", name);
          FindByQueryAccess<Media> queryAccess = mediaAccessFactory.createFindByQueryAccess();
          queryAccess.setQuery(query);
          queryAccess.setParameters(parameters);
          queryAccess.execute();
          List<Media> result = queryAccess.getResult();
          return result;
      }
     
     /**
      * <!-- begin-user-doc -->
      * <!-- end-user-doc -->
      *
      */
      public List<Media> findMediaByCharacter(int libraryId, String characterName)  {
          String query = "select media from Media as media where media.characters.name = :characterName " +
              "and media.physicalMedia.library.id = :libraryId";
          Map parameters = new HashMap();
          parameters.put("libraryId", libraryId);
          parameters.put("characterName", characterName);
          FindByQueryAccess<Media> queryAccess = mediaAccessFactory.createFindByQueryAccess();
          queryAccess.setQuery(query);
          queryAccess.setParameters(parameters);
          queryAccess.execute();
          List<Media> result = queryAccess.getResult();
          return result;       
      }
     
  
   

} 