package compiledtemplates;

import java.util.*;
import util.EcoreGenerationHelper;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.codegen.util.*;

public class AbstractFactory
{
  protected static String nl;
  public static synchronized AbstractFactory create(String lineSeparator)
  {
    nl = lineSeparator;
    AbstractFactory result = new AbstractFactory();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + "package ";
  protected final String TEXT_3 = ";" + NL;
  protected final String TEXT_4 = NL + NL + "/**" + NL + " * <p>" + NL + " * Abstract Factory that creates concrete factory for ";
  protected final String TEXT_5 = " ";
  protected final String TEXT_6 = " objects. " + NL + " * By default the factory implementation is " + NL + " * ";
  protected final String TEXT_7 = ".";
  protected final String TEXT_8 = "FactoryImpl, " + NL + " * but it can be changed by dependency injection of another FactoryConfiguration." + NL + " * </p>" + NL + " * <p>" + NL + " * Abstract factory design pattern." + NL + " * </p>" + NL + " * <!-- begin-user-doc -->" + NL + " * <!-- end-user-doc -->" + NL + " *" + NL + " * @generated" + NL + " */" + NL + "public abstract class ";
  protected final String TEXT_9 = "Factory {" + NL + "    /** @generated */" + NL + "    private static  ";
  protected final String TEXT_10 = "Factory singletonInstance;" + NL + "    " + NL + "    /**" + NL + "     * By default ";
  protected final String TEXT_11 = ".";
  protected final String TEXT_12 = "FactoryImpl " + NL + "     * will be used as concrete factory." + NL + "     * @generated" + NL + "     */" + NL + "    private static FactoryConfiguration config = new FactoryConfiguration() {" + NL + "        public String getFactoryImplementationClassName() {" + NL + "            return \"";
  protected final String TEXT_13 = ".";
  protected final String TEXT_14 = "FactoryImpl\";" + NL + "        }" + NL + "        " + NL + "    };" + NL + "    " + NL + "    /**" + NL + "     * Change configuration. Necessary for convenient unit testing." + NL + "     * @param aConfig new configuration object" + NL + "     * @generated" + NL + "     */" + NL + "    public static void setConfiguration(FactoryConfiguration aConfig) {" + NL + "        config = aConfig;" + NL + "    }" + NL + "    " + NL + "    /** @generated */" + NL + "    public static ";
  protected final String TEXT_15 = "Factory getInstance() {" + NL + "        if (singletonInstance == null) {" + NL + "            singletonInstance = createInstance();" + NL + "        }" + NL + "        return singletonInstance;" + NL + "    }" + NL + "" + NL + "    /** @generated */" + NL + "    private static  ";
  protected final String TEXT_16 = "Factory createInstance() {" + NL + "        return (";
  protected final String TEXT_17 = "Factory) FactoryHelper.newInstanceFromName(" + NL + "            config.getFactoryImplementationClassName());" + NL + "    }" + NL + "    " + NL + "    /** @generated */" + NL + "    protected Class getPersistentClass() {" + NL + "        return ";
  protected final String TEXT_18 = ".class;" + NL + "    }" + NL;
  protected final String TEXT_19 = NL + "    /**" + NL + "     * <!-- begin-user-doc -->" + NL + "     * <!-- end-user-doc -->" + NL + "     * @generated" + NL + "     */" + NL + "    public abstract ";
  protected final String TEXT_20 = " create";
  protected final String TEXT_21 = "();" + NL + "     ";
  protected final String TEXT_22 = NL + NL + NL + "} ";

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    

    EClass eClass = (EClass) argument;
EPackage ePackage = eClass.getEPackage();

if (!eClass.getName().endsWith("Repository")) {
    throw new IllegalArgumentException("Expect name of class argument to end with \"Repository\""); 
}
String baseName = eClass.getName().substring(0, eClass.getName().length() - "Repository".length());
String productType = "Access";

EcoreGenerationHelper h = new EcoreGenerationHelper();
String apiPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".accessapi";
String implPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".accessimpl";
String domainPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".domain";
String fwApiPackageName = h.getQualifiedName(ePackage.getESuperPackage().getESuperPackage()) + ".framework.accessapi";
String fwUtilPackageName = h.getQualifiedName(ePackage.getESuperPackage().getESuperPackage()) + ".framework.util";
h.makeImportManager(apiPackageName);

    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(apiPackageName);
    stringBuffer.append(TEXT_3);
    
StringBuffer importStringBuffer = stringBuffer;
int importInsertionPoint = stringBuffer.length();
h.getImportManager().addCompilationUnitImports(stringBuffer.toString());
h.addImport(fwUtilPackageName + ".FactoryConfiguration");
h.addImport(fwUtilPackageName + ".FactoryHelper");
h.addImport(domainPackageName + "." + baseName);
h.addImport(fwApiPackageName + ".*");

    stringBuffer.append(TEXT_4);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(implPackageName);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_8);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_9);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_10);
    stringBuffer.append(implPackageName);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(implPackageName);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_14);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_15);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_16);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_17);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_18);
    for (EOperation op : h.getOperations(eClass)) {
  if (h.getAnnotation(op, "noaccessobject") != null) continue;
  String mappedOpName = h.getMappedOperationName(op); 

    stringBuffer.append(TEXT_19);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_20);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_21);
    }
    stringBuffer.append(TEXT_22);
    importStringBuffer.insert(importInsertionPoint, h.getImportManager().computeSortedImports());
    return stringBuffer.toString();
  }
}
