package compiledtemplates;

import java.util.*;
import util.DatabaseGenerationHelper;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.codegen.util.*;

public class DDL
{
  protected static String nl;
  public static synchronized DDL create(String lineSeparator)
  {
    nl = lineSeparator;
    DDL result = new DDL();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + "CREATE TABLE ";
  protected final String TEXT_2 = " (";
  protected final String TEXT_3 = NL + "  UUIDSTRING VARCHAR(255) NOT NULL, ";
  protected final String TEXT_4 = NL + "  ";
  protected final String TEXT_5 = " ";
  protected final String TEXT_6 = ",";
  protected final String TEXT_7 = NL + "  ";
  protected final String TEXT_8 = NL + "        <index column=\"";
  protected final String TEXT_9 = "_INDEX\" />";
  protected final String TEXT_10 = NL + "  ";
  protected final String TEXT_11 = " ";
  protected final String TEXT_12 = ",";
  protected final String TEXT_13 = NL + "  ";
  protected final String TEXT_14 = ",";
  protected final String TEXT_15 = NL + "  ";
  protected final String TEXT_16 = NL + "  ";
  protected final String TEXT_17 = " ";
  protected final String TEXT_18 = ",";
  protected final String TEXT_19 = NL + "  ";
  protected final String TEXT_20 = NL + ");" + NL + "     ";
  protected final String TEXT_21 = NL;
  protected final String TEXT_22 = NL + "CREATE TABLE ";
  protected final String TEXT_23 = " (";
  protected final String TEXT_24 = NL + "  ";
  protected final String TEXT_25 = " ";
  protected final String TEXT_26 = ",";
  protected final String TEXT_27 = NL + "  ";
  protected final String TEXT_28 = ",";
  protected final String TEXT_29 = NL + ");" + NL;
  protected final String TEXT_30 = NL;
  protected final String TEXT_31 = NL;

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    

    EPackage ePackage = (EPackage) argument;

DatabaseGenerationHelper h = new DatabaseGenerationHelper();

    for (EClass eClass : h.getClassesInCreateOrder(ePackage)) {
  boolean hasSuperClass = !h.getExtends(eClass).isEmpty();
  boolean hasOneReferences = !h.getAllOneReferences(eClass).isEmpty();

    stringBuffer.append(TEXT_1);
    stringBuffer.append(h.getDatabaseName(eClass) );
    stringBuffer.append(TEXT_2);
    if (h.getNaturalKeys(eClass).isEmpty()) {
    stringBuffer.append(TEXT_3);
    }
    for (Iterator<EAttribute> iter = h.getAttributes(eClass).iterator(); iter.hasNext();) {
    EAttribute attribute = iter.next();
  
    stringBuffer.append(TEXT_4);
    stringBuffer.append(h.getDatabaseName(attribute));
    stringBuffer.append(TEXT_5);
    stringBuffer.append(h.getDatabaseType(attribute));
    
    // skip , on last line
    if (iter.hasNext() || hasOneReferences || hasSuperClass) {
    stringBuffer.append(TEXT_6);
    }
    }
    stringBuffer.append(TEXT_7);
    for (Iterator<EReference> iter = h.getAllOneReferences(eClass).iterator(); iter.hasNext();) {
    EReference ref = iter.next();
  
    if ("list".equals(h.getCollectionType(ref))) {
    stringBuffer.append(TEXT_8);
    stringBuffer.append(h.getDatabaseName(ref));
    stringBuffer.append(TEXT_9);
    }
    stringBuffer.append(TEXT_10);
    stringBuffer.append(h.getForeignKeyName(ref));
    stringBuffer.append(TEXT_11);
    stringBuffer.append(h.getForeignKeyType(ref));
    stringBuffer.append(TEXT_12);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(h.getForeignKeyConstraint(ref));
    
    // skip , on last line
    if (iter.hasNext() || hasSuperClass) {
    stringBuffer.append(TEXT_14);
    }
    }
    stringBuffer.append(TEXT_15);
    if (hasSuperClass) {
    EClass superClass = h.getExtends(eClass).get(0);
  
    stringBuffer.append(TEXT_16);
    stringBuffer.append(h.getForeignKeyName(superClass));
    stringBuffer.append(TEXT_17);
    stringBuffer.append(h.getForeignKeyType(superClass));
    stringBuffer.append(TEXT_18);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(h.getForeignKeyConstraint(superClass));
    }
    stringBuffer.append(TEXT_20);
    }
    stringBuffer.append(TEXT_21);
    for (EClass eClass : h.resolveManyToManyRelations(ePackage)) {
    stringBuffer.append(TEXT_22);
    stringBuffer.append(h.getDatabaseName(eClass) );
    stringBuffer.append(TEXT_23);
    for (Iterator<EReference> iter = h.getAllOneReferences(eClass).iterator(); iter.hasNext();) {
    EReference ref = iter.next();
  
    stringBuffer.append(TEXT_24);
    stringBuffer.append(h.getForeignKeyName(ref));
    stringBuffer.append(TEXT_25);
    stringBuffer.append(h.getForeignKeyType(ref));
    stringBuffer.append(TEXT_26);
    stringBuffer.append(TEXT_27);
    stringBuffer.append(h.getForeignKeyConstraint(ref));
    
    // skip , on last line
    if (iter.hasNext()) {
    stringBuffer.append(TEXT_28);
    }
    }
    stringBuffer.append(TEXT_29);
    }
    stringBuffer.append(TEXT_30);
    stringBuffer.append(TEXT_31);
    return stringBuffer.toString();
  }
}
